// Compare speed of circle computations.  DJS 2016aug20

#include <cstdio>
#include <cmath>
#include <algorithm>

volatile float x;
volatile float y;

int main (int argc, char *argv[])
{
  int sz = 12;
  int N_circle = 1000000;

  for (int i_arg = 1; i_arg < argc; i_arg++)
    {
      char *option = argv[i_arg];

      if (sscanf (option, "%d", &sz) == 1)
          break;
    }

  fprintf(stderr, "sz=%d ", sz);
  int div = static_cast <int> (M_PI * sz / 12);
  if (! (div % 2))
    div += 1;               // ensure odd number for left/right symmetry
  div = std::max (div, 3);  // ensure at least a few vertices are drawn
  fprintf(stderr, "div=%d ", div);

#ifndef MATROT
  fprintf(stderr, "alg=trig");
  for (int i_circle = 0; i_circle < N_circle; i_circle++)
    {
      double ang_step = M_PI / div;

//      glBegin (GL_POLYGON);
      for (double ang = 0; ang < 2*M_PI; ang += ang_step)
//        glVertex2d (sz/6*cos (ang), sz/6*sin (ang));
        {
          x = sz/6*cos (ang);
          y = sz/6*sin (ang);
        }
//      glEnd ();
    }
#else
  fprintf(stderr, "alg=matrot");
  div *= 2;

  for (int i_circle = 0; i_circle < N_circle; i_circle++)
    {
      float m11 = cos (M_PI/div);
      float m21 = sin (M_PI/div);
      float m12 = -m21;
      float m22 = m11;
      float x = sz/2;
      float y = 0;

//      glBegin (filled ? GL_POLYGON : GL_LINE_LOOP);
      for (int i = 0; i < div; i++)
        {
//          glVertex2d (x, y);
          float xx = x;
          x = m11*xx + m12*y;
          y = m21*xx + m22*y;
        }
//         glEnd ();
    }
#endif

}
